#cs ----------------------------------------------------------------------------
	
	AutoIt Version : 3.3.10.2
	Auteur:         Uranium & balcksoul305
	
	Fonction du Script :
	Permet le test du rseau neuronal responsable de l'apprentissage des chiffres sur affichage 7-segments
	
#ce ----------------------------------------------------------------------------

#include <ButtonConstants.au3>
#include <GUIConstantsEx.au3>
#include <ProgressConstants.au3>
#include <WindowsConstants.au3>
#include <WinAPIGdi.au3>

Global $Form1_1 = GUICreate("Form1", 503, 303, 192, 124)
Global $Progress1 = GUICtrlCreateButton("", 104, 33, 81, 25)
GUICtrlSetBkColor(-1, 0xB4B4B4)
Global $Progress2 = GUICtrlCreateButton("", 104, 81, 81, 25)
GUICtrlSetBkColor(-1, 0xB4B4B4)
Global $Progress3 = GUICtrlCreateButton("", 104, 121, 81, 25)
GUICtrlSetBkColor(-1, 0xB4B4B4)
Global $Progress4 = GUICtrlCreateButton("", 88, 33, 17, 65)
GUICtrlSetBkColor(-1, 0xB4B4B4)
Global $Progress5 = GUICtrlCreateButton("", 184, 33, 17, 65)
GUICtrlSetBkColor(-1, 0xB4B4B4)
Global $Progress6 = GUICtrlCreateButton("", 88, 97, 17, 49)
GUICtrlSetBkColor(-1, 0xB4B4B4)
Global $Progress7 = GUICtrlCreateButton("", 184, 97, 17, 49)
GUICtrlSetBkColor(-1, 0xB4B4B4)
Global $Button1 = GUICtrlCreateButton("Devine", 144, 240, 177, 25)
GUISetState(@SW_SHOW)

Local $inputsArray, $fileDir, $ret
Local $buttonState[8] = [0, 0, 0, 0, 0, 0, 0, 1] ; Initialisation des entres


While 1
	$nMsg = GUIGetMsg()
	Switch $nMsg
		Case $GUI_EVENT_CLOSE
			Exit
		Case $Progress1
			_boum("1")
		Case $Progress2
			_boum("2")
		Case $Progress3
			_boum("3")
		Case $Progress4
			_boum("4")
		Case $Progress5
			_boum("5")
		Case $Progress6
			_boum("6")
		Case $Progress7
			_boum("7")
		Case $Button1
			$sel = _GetHighestWeightedAverageSectionName(@ScriptDir & "\save.ini", $buttonState) ; rcupration du chiffre ayant le plus de ressemblance avec celui dessin
			If $tempMax >= 5 Then ; Permet de filtrer les chiffres mal-dessins (Le seuil de 5 tant celui le mme que le seuil d'activation du script train !) <- seuil  amliorer !
				MsgBox(0, "", "Je pense qu'il s'agit du chiffre " & $sel)
			Else
				MsgBox(0, "", "Je ne reconnait pas ce chiffre. L'avez-vous bien crit ?")
			EndIf
	EndSwitch
WEnd


; #FONCTION# ====================================================================================================================
; Nom ..........: _boum
; Description ...: Permet d'activer/dsactiver un segment & attribut son statut ( activer/dsactiver)  l'array des entres
; Syntaxe ........: _boum($var1)
; Parametres ....: $var1 - Numro lie  un segment
; Valeurs retournes .: Aucune
; Autheur ........: Uranium
; ===============================================================================================================================
Func _boum($var)
	If $buttonState[Int($var) - 1] Then ; vert
		GUICtrlSetBkColor(Execute("$Progress" & $var), 0xB4B4B4)
		$buttonState[Int($var) - 1] = 0
	Else
		GUICtrlSetBkColor(Execute("$Progress" & $var), 0x00FF00)
		$buttonState[Int($var) - 1] = 1
	EndIf
EndFunc   ;==>_boum

; #FONCTION# ====================================================================================================================
; Nom ..........: _GetHighestWeightedAverageSectionName
; Description ...: Permet de rcuprer le chiffre ayant le plus de compatibilits avec celui dessin ( en faisant une somme pondre)
; Syntaxe ........: _GetHighestWeightedAverageSectionName($fileDir, $inputsArray)
; Parametres ....: $fileDir - Chemin vers un fichier contenant la sauvegarde
;~ ; 				    $inputsArray  Array des entres
; Valeurs retournes .: Le chiffre ayant la plus grande compatibilit
; Autheur ........: blacksoul305
; ===============================================================================================================================
Func _GetHighestWeightedAverageSectionName($fileDir, $inputsArray)
	Local $tempNames, $tempKeys
	Global $tempMax = 0

	$tempNames = IniReadSectionNames($fileDir)
	Dim $tempArray[$tempNames[0] + 1]
	$tempArray[0] = $tempNames[0]

	For $i = 1 To $tempNames[0]

		$tempKeys = IniReadSection($fileDir, $tempNames[$i])
		$tempArray[$i - 1] = 0

		For $j = 1 To $tempKeys[0][0]
			$tempArray[$i - 1] += $inputsArray[$j - 1] * $tempKeys[$j][1]
		Next

		If $tempArray[$i - 1] > $tempMax Then
			$tempMax = $tempArray[$i - 1]
			$ret = $tempNames[$i]
		EndIf
	Next
	Return $ret
EndFunc   ;==>_GetHighestWeightedAverageSectionName
