#cs ----------------------------------------------------------------------------
	
	AutoIt Version : 3.3.10.2
	Auteur:         Uranium
	
	Fonction du Script :
	OCR 7-segments  l'aide d'un rseau neuronal
	
#ce ----------------------------------------------------------------------------

#include <GUIConstantsEx.au3>
#include <ProgressConstants.au3>
#include <WindowsConstants.au3>

Global $Form1_1 = GUICreate("Form1", 500, 300, 192, 124) ; Cration de l'interface
Global $Progress1 = GUICtrlCreateProgress(152, 48, 145, 17)
Global $Progress2 = GUICtrlCreateProgress(152, 112, 145, 17)
Global $Progress3 = GUICtrlCreateProgress(152, 176, 145, 17)
Global $Progress4 = GUICtrlCreateProgress(128, 48, 25, 73, $PBS_VERTICAL)
Global $Progress5 = GUICtrlCreateProgress(296, 48, 25, 73, $PBS_VERTICAL)
Global $Progress6 = GUICtrlCreateProgress(128, 120, 25, 73, $PBS_VERTICAL)
Global $Progress7 = GUICtrlCreateProgress(296, 120, 25, 73, $PBS_VERTICAL)
GUISetState(@SW_SHOW)


For $currentN = 1 To 9 ; Permet l'apprentisage d'un chiffre ( valeur de $currentN )
	Global $count, $W, $X
	Local $array[8][2] ;Initialisation d'une array contenant la valeur d'entre et son poids associ  chaque segment( les entres tant dans la premire colonne [x][0] et les poids sur la seconde [x][1] )
	_Init() ; On initialise tous les poids et toutes les entres  0
	ConsoleWrite("La chiffre a trait est " & $currentN & @CRLF) ; On indique le chiffre que nous voulons faire apprendre au programme


	Do ; Nous voulons faire au moins 300 entrainement par chiffre


		For $j = 1 To 9 ; Pour chaque chiffre que nous voulons faire apprendre ($CurrentN) , nous lui montrerons tout les chiffres xistant ($j) pour son entrainement

			_TrainOn($j) ; Affichage du chiffre $j sur l'afficheur 7-segments
			_Get() ; On rcupre les entres
			$sum = 0 ; On initialise la somme "pondre"
			For $i = 1 To 7
				$sum += $array[$i][0] * $array[$i][1]
			Next
			$sum += $W ; Calcul de la somme
			If $sum > 5 Then ; Attribution de la sortie par apport  la valeur de la somme et du seuil d'activation de 5
				$s = 1
			Else
				$s = 0
			EndIf
			$h = _Correspondance($currentN, $j); Teste si le chiffre en cours d'apprentissage correspond au chiffre donn durant l'entrainement


			ConsoleWrite("Chiffre : " & $currentN & " / Actuel : " & $j & " / Correspondance : " & $s & " / " & $h & @CRLF)
			; Permet d'afficher en console le chiffre en cours d'apprentissage ($CurrentN) , le chiffre donn pendant l'entrainement ($j) ,
			;la valeur de correspondance ($h) ainsi que la sortie ($s) ( afin de voir  partir de quel moment le rseau neuronal dtecte correctement le bon chiffre )
			; Utile pour dtecter les erreurs , et pour pouvoir amliorer notre programme en changeant le seuil d'activation / nombre d'entrainement  faire

			_Train() ; Correction des poids
			_NRand() ; On remet les entres  zro pour passer au chiffres suivant
			$count += 1

		Next


	Until $count > 300
	_Save(@ScriptDir & "\save.ini", $currentN, $array) ; On sauvegarde pour une utilisation extrieure

Next



; #FONCTION# ====================================================================================================================
; Nom ..........: _Get
; Description ...: Permet de rcuprer les entres de l'affichage 7-segments
; Syntaxe ........: _Get()
; Parametres ....: Aucun
; Valeurs retournes .: Aucune
; Autheur ........: Uranium
; ===============================================================================================================================
Func _Get()
	For $k = 1 To 7
		If GUICtrlRead(Execute("$Progress" & $k)) = 100 Then
			$array[$k][0] = 1
		Else
			$array[$k][0] = 0
		EndIf
	Next
EndFunc   ;==>_Get

; #FONCTION# ====================================================================================================================
; Nom ..........: _TrainOn
; Description ...: Permet l'affichage d'un chiffre $j sur l'afficheur 7-segments
; Syntaxe ........: _TrainOn()
; Parametres ....: Aucun
; Valeurs retournes .: Aucune
; Autheur ........: Uranium
; ===============================================================================================================================

Func _TrainOn($g)
	Switch $g
		Case 1
			GUICtrlSetData($Progress5, 100)
			GUICtrlSetData($Progress7, 100)
		Case 2
			GUICtrlSetData($Progress1, 100)
			GUICtrlSetData($Progress2, 100)
			GUICtrlSetData($Progress3, 100)
			GUICtrlSetData($Progress5, 100)
			GUICtrlSetData($Progress6, 100)
		Case 3
			GUICtrlSetData($Progress1, 100)
			GUICtrlSetData($Progress2, 100)
			GUICtrlSetData($Progress3, 100)
			GUICtrlSetData($Progress5, 100)
			GUICtrlSetData($Progress7, 100)
		Case 4
			GUICtrlSetData($Progress2, 100)
			GUICtrlSetData($Progress7, 100)
			GUICtrlSetData($Progress4, 100)
			GUICtrlSetData($Progress5, 100)
		Case 5
			GUICtrlSetData($Progress1, 100)
			GUICtrlSetData($Progress2, 100)
			GUICtrlSetData($Progress3, 100)
			GUICtrlSetData($Progress7, 100)
			GUICtrlSetData($Progress4, 100)
		Case 6
			GUICtrlSetData($Progress1, 100)
			GUICtrlSetData($Progress2, 100)
			GUICtrlSetData($Progress3, 100)
			GUICtrlSetData($Progress6, 100)
			GUICtrlSetData($Progress4, 100)
			GUICtrlSetData($Progress7, 100)
		Case 7
			GUICtrlSetData($Progress1, 100)
			GUICtrlSetData($Progress5, 100)
			GUICtrlSetData($Progress7, 100)
		Case 8
			GUICtrlSetData($Progress1, 100)
			GUICtrlSetData($Progress3, 100)
			GUICtrlSetData($Progress2, 100)
			GUICtrlSetData($Progress4, 100)
			GUICtrlSetData($Progress5, 100)
			GUICtrlSetData($Progress6, 100)
			GUICtrlSetData($Progress7, 100)
		Case 9
			GUICtrlSetData($Progress1, 100)
			GUICtrlSetData($Progress2, 100)
			GUICtrlSetData($Progress3, 100)
			GUICtrlSetData($Progress5, 100)
			GUICtrlSetData($Progress7, 100)
			GUICtrlSetData($Progress4, 100)
	EndSwitch
EndFunc   ;==>_TrainOn


; #FONCTION# ====================================================================================================================
; Nom ..........: _NRand
; Description ...: Remet toutes les entres  0
; Syntaxe ........: _NRand()
; Parametres ....: Aucun
; Valeurs retournes .: Aucune
; Autheur ........: Uranium
; ===============================================================================================================================
Func _NRand()
	For $i = 1 To 7
		GUICtrlSetData(Execute("$Progress" & $i), 0)
	Next
EndFunc   ;==>_NRand

; #FUNCTION# ====================================================================================================================
; Nom ..........: _Init
; Description ...: Initialise les valeurs d'entres et leurs poids  0
; Syntaxe ........: _Init()
; Parametres ....: Aucun
; Return values .: Aucune
; Author ........: Uranium
; ===============================================================================================================================
Func _Init()
	$count = 0
	$X = 0
	$W = 0
	For $i = 1 To 7
		$array[$i][1] = 0
	Next
EndFunc   ;==>_Init

; #FONCTION# ====================================================================================================================
; Nom ..........: _Train
; Description ...: Permet la correction des poids
; Syntaxe ........: _Train()
; Parametres ....: Aucun
; Valeurs retournes .: Aucune
; Autheur ........: Uranium
; ===============================================================================================================================
Func _Train()
	For $i = 1 To 7
		$array[$i][1] = $array[$i][1] + 0.1 * $array[$i][0] * ($h - $s)
	Next
	$W = $W + 0.1 * ($h - $s)
EndFunc   ;==>_Train

Func _Correspondance($var1, $var2) ; Teste si le chiffre en cours d'apprentissage correspond au chiffre donn durant l'entrainement
	If $var1 = $var2 Then
		Return 1
	Else
		Return 0
	EndIf
EndFunc   ;==>_Correspondance

Func _Save($fileDir, $sectionName, $array2D) ; Permet la sauvegarde des poids pour une utilisation extrieure
	For $i = 1 To UBound($array2D) - 1
		IniWrite($fileDir, $sectionName, $i, $array2D[$i][1])
	Next
	IniWrite($fileDir, $sectionName, 8, $W)
EndFunc   ;==>_Save
